<?php
/* Filters out exploits

Filters some common exploits like xss,lfi and sqli from a string.

PARAMETERS:
$sString: text string
$bXSS: filters xss
$bFI: filters file injections
$bSQL: filters sql injections

RETURNS:
STRING: filtered data
*/

function ExploitFilter($sString,$bXSS=false,$bFI=false,$bSQL=false){
	if($bXSS==false && $bFI==false && $bSQL==false){
		return($sString);
	}
	if(!is_string($sString)){
		return($sString);
	}
	if($bXSS){
		$sString = strip_tags($sString);
	}
	if($bFI){
		$sString = str_replace("../","",$sString);
		$sString = str_replace("./","",$sString);
		$sString = preg_replace('[^a-zA-Z0-9\-_\.\/ ]','',$sString);
	}
	if($bSQL){
		$sString = mysql_real_escape_string($sString);
	}
	return($sString);
}
?>