<?php
/* Load the environment, sets the missing default paths and variable values */

// ok let's make sure the scripts can't be accessed directly
define('IN_SCRIPT',1);
if(!defined('SCREEN')){
	// if the script isn't included on index.php, but from a stand-alone app like the screen.php iframe output files 
	@include("paths.php");
}
if(!isset($_PATHS['root'])){
	// if we can't load paths no need to bother doing anything anymore
	die((!@file_exists("paths.php") ? "Failed to load <b>paths.php</b>" : "Unexpected data in <b>paths.php</b>"));
}
// need the context variables also, just to keep track of the user's current action
if(!file_exists($_PATHS['root']."/vars.php") ? die("Root path in <b>paths.php</b> is invalid") : include($_PATHS['root']."/vars.php"));
// does the have any sort of ip access configuration specified?
if(isset($_CONTEXT['ip_access']) && $_CONTEXT['ip_access']){
	if(!in_array($_SERVER['REMOTE_ADDR'],$_CONTEXT['ip_allowed'])){
		// don't we all love Google? :)
		header("Location: http://www.google.com");
		exit;
	}
}
else{
	$_CONTEXT['warn_no_ip'] = 1;
}
// set hacksuite version
include($_PATHS['data_root']."/version.php");
// style variable, if setup fails load the default style
include($_PATHS['data_root']."/style.php");
if(isset($_STYLE) && strlen($_STYLE)>0){
	// is the location ok, let's do a test..
	if(file_exists($_PATHS['root']."/Templates/".$_STYLE."/index.php")){
		// setup the correct location of template files
		$_PATHS['style_root'] = $_PATHS['root']."/Templates/".$_STYLE;
		// user defined style, if this stays empty use the default style
		$_PATHS['style_user'] = $_STYLE;
		// the current style http root
		$_PATHS['style_root_http'] = $_PATHS['root_http']."/Templates/".$_STYLE;
	}
	else{
		// setup the correct location of template files
		$_PATHS['style_root'] = $_PATHS['style_default_root'];
		// the current style http root
		$_PATHS['style_root_http'] = $_PATHS['style_default_root_http'];
	}
	$_PATHS['end'] = $_PATHS['style_root']."/error/index.php";
}
// function to get directories from a directory
include_once($_PATHS['functions_root']."/getdirbydir.php");
// function to filter out evil content
include_once($_PATHS['functions_root']."/exploitfilter.php");
// function to see if a file is present
include_once($_PATHS['functions_root']."/isthere.php");
// well we can expect that things are ok now, let's first get the module stuff together
if(false!==($aDirs = GetDirByDir($_PATHS['root'],0))){
	for($x=0;$x<count($aDirs);$x++){
		// modules start with 'thc_'
		if(substr($aDirs[$x],0,4)=="thc_"){
			// get the properties for the module
			$sSetup = $_PATHS['root']."/".$aDirs[$x]."/setup.php";
			if(file_exists($sSetup)){
				include($sSetup);
				$_CONTEXT['modules'][$aDirs[$x]] = $aProperties;
				if(!isset($_CONTEXT['modules'][$aDirs[$x]])){
					// make sure the module dir can be used as array key
					die("Invalid module name, make sure it matches this pattern: thc_[a-zA-Z0-9_]{2,3}");
				}
			}
			else{
				die("No setup file present for module <b>".$aDirs[$x]."</b>");
			}
		}
	}
}
// request for module, if it exists set it as default to make sure we are working with the right modules
if(isset($_GET['module']) || defined('SCREEN')){
	$_GET['module'] = (!isset($_GET['module']) ? $_MODULE_C : $_GET['module']);
	if(isset($_CONTEXT['modules'][$_GET['module']])){
		// set as current module
		$_CONTEXT['module_current'] = $_GET['module'];
		// default module root
		$_PATHS['module_default_root'] = $_PATHS['root']."/".$_CONTEXT['module_current'];
		// default module root http
		$_PATHS['module_default_root_http'] = $_PATHS['root_http']."/".$_CONTEXT['module_current'];
	}
}
// load the link maps
include($_PATHS['data_root']."/link_map.php");
include($_PATHS['data_root']."/links_thc.php");
// load widgets
include($_PATHS['data_root']."/widgets.php");
// default appearance of widgets and other stuff
include_once($_PATHS['data_root']."/appearance.php");
// show hints
include($_PATHS['data_root']."/hints.php");
// if we have a current module let's load it up
if($_CONTEXT['module_current']!="" && !defined('SCREEN')){
	include($_PATHS['module_default_root']."/index.php");
}
// if no module has been specified or any other location the current style's index page will be displayed
?>